#!/usr/bin/env node
"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}require("loud-rejection/register");var TS=_interopDefault(require("trie-search")),RenderKid=_interopDefault(require("renderkid")),prettyJson=_interopDefault(require("jsome")),chalk=require("chalk"),transmute=require("transmutation"),transmute__default=_interopDefault(transmute),fs=_interopDefault(require("fs")),unglob=_interopDefault(require("glob")),match=_interopDefault(require("minimatch")),promisify=_interopDefault(require("es6-promisify")),path=require("path"),findUp=_interopDefault(require("find-up")),rollup=require("rollup"),uglifyEs=require("uglify-es"),babel=_interopDefault(require("rollup-plugin-babel")),uglify=_interopDefault(require("rollup-plugin-uglify")),filesize=_interopDefault(require("rollup-plugin-filesize")),nodeResolve=_interopDefault(require("rollup-plugin-node-resolve")),executable=_interopDefault(require("rollup-plugin-executable")),asyncToGenerator=function(e){return function(){var t=e.apply(this,arguments);return new Promise(function(e,n){function r(a,i){try{var l=t[a](i),o=l.value}catch(e){return void n(e)}if(!l.done)return Promise.resolve(o).then(function(e){r("next",e)},function(e){r("throw",e)});e(o)}return r("next")})}},_extends=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},createSearcher=({commands:e=[]}={})=>{const t=e.map(e=>{const t=Array.isArray(e.aliases)?e.aliases:[e.aliases];return _extends({},e,{tokens:[e.name,...t].join(" ")})}),n=new TS(["tokens"]);return n.addAll(t),n};const isPromise=e=>!!e&&("object"==typeof e||"function"==typeof e)&&"function"==typeof e.then;var createExecutor=({defaultStyle:e,defaultRenderer:t=console.log})=>n=>(...r)=>{const a=n.run(...r),i=n.renderer||t,l=new RenderKid;if(l.style(e),isPromise(a))return a.then(e=>n.template?l.render(n.template(e)):e).then(i);return i(n.template?l.render(n.template(a)):a)};const configureKli=({defaultStyle:e,defaultRenderer:t=console.log}={})=>({commands:n=[]}={})=>{if(!Array.isArray(n))throw new Error("Commands must be an array");if(0===n.length)throw new Error("No commands defined");if(n.forEach(e=>{if("function"!=typeof e.run)throw new Error("All commands must have a run method")}),1===n.length)return{execute:()=>n[0].run()};const r=createSearcher({commands:n}),a=createExecutor({defaultStyle:e,defaultRenderer:t});return{execute:e=>{const t=r.get(e[0])[0];return a(t)()}}},configure=configureKli,kli$1=configureKli({defaultRenderer:console.log});configureKli({defaultRenderer:console.log});var style={title:{display:"block",color:"bright-white",marginLeft:2,marginBottom:1},check:{display:"block",marginLeft:4},success:{display:"block",color:"grey",bullet:`"${chalk.green("✔")} "`},fail:{display:"block",color:"red",bullet:`"${chalk.red("✖")} "`},list:{display:"block",marginTop:1},item:{display:"block",marginBottom:1},attr:{display:"block",marginLeft:2},key:{color:"grey",marginRight:1},value:{color:"white"},bar:{display:"block",color:"green",bullet:`"${chalk.green("────────────────────────────────────────────────────────────────────────────────")}"`},h1:{display:"block",color:"bright-white",marginLeft:2}},packageListTemplate=e=>`\n    <bar>-</bar>\n    <h1>Package List</h1>\n    <bar>-</bar>\n    <list>\n        ${e.map(e=>`<item>\n                <attr><key>Name:</key><value>${e.name}</value></attr>\n                <attr><key>Version:</key><value>${e.version||"No version"}</value></attr>\n            </item>`).join("")}\n    </list>\n    `,checkedPackagesTemplate=e=>`\n    <bar>-</bar>\n    <h1>Checked Packages</h1>\n    <bar>-</bar>\n    <list>\n        ${e.map(e=>`<item>\n                <title>${e.name}</title>\n                ${Object.entries(e.checks).map(([e,t])=>t?`<check><success>${e}</success></check>`:`<check><fail>${e}</fail></check>`).join("")}\n                <check>${Array(Object.keys(e.checks).reduce((e,t)=>e.length>t.length?e:t).length+3).join("─")}</check>\n                <check>${e.publishable?"<success>publishable</success>":"<fail>not publishable</fail>"}</check>\n            </item>`).join("")}\n    </list>\n    `;const glob=promisify(unglob),lstat=promisify(fs.lstat),have=e=>t=>match(e,t);var findPackages=({root:e=".",exclude:t=[]}={})=>new Promise((()=>{var n=asyncToGenerator(function*(n,r){try{const a=path.resolve(e,"src/node_modules");if(!(yield lstat(a)).isDirectory)return r("NO");const i=path.resolve(a,"**/package.json");return n((yield glob(i)).filter(function(e){return!t.some(have(e))}).map(function(t){const n=require(t);return{dir:path.relative(e,path.dirname(t)),name:n.name,bin:n.bin,main:n.main,config:n}}).filter(function(e){return e.name}))}catch(e){return r(e)}});return function(e,t){return n.apply(this,arguments)}})()),findRepoRoot=({anchor:e=".git"}={})=>findUp(e).then(path.dirname),list=()=>transmute.transmute({}).extend("root",findRepoRoot).extend("exclude",["**/fixtures/**"]).extend("packages",findPackages).then(transmute.isolate("packages"));const lstat$1=promisify(fs.lstat);var checkPackages=({root:e,packages:t=[]}={})=>new Promise((()=>{var n=asyncToGenerator(function*(n){if(0===t.length)return n([]);return n(yield Promise.all(t.map((()=>{var t=asyncToGenerator(function*(t){const n={};n["has package name"]=!!t.name;try{const r=path.resolve(e,t.dir,"readme.md"),a=yield lstat$1(r);n["has readme file"]=!!a.isFile}catch(e){n["has readme file"]=!1}try{if(t.main||!t.bin){const r=path.resolve(e,t.dir,t.main||"index.js"),a=yield lstat$1(r);n["has main and/or all bin files"]=!!a.isFile}if(t.bin){const r=Object.values(t.bin),a=yield Promise.all(r.map(function(n){return path.resolve(e,t.dir,n)}).map((()=>{var e=asyncToGenerator(function*(e){return lstat$1(e)});return function(t){return e.apply(this,arguments)}})()));n["has main and/or all bin files"]=!a.some(function(e){return!e.isFile})}}catch(e){n["has main and/or all bin files"]=!1}return Object.values(n).some(function(e){return!e})?_extends({},t,{checks:n,publishable:!1}):_extends({},t,{checks:n,publishable:!0})});return function(e){return t.apply(this,arguments)}})())))});return function(e){return n.apply(this,arguments)}})()),findBaseConfig=({root:e="."}={})=>require(path.resolve(e,"package.json")),check=()=>transmute.transmute({}).extend("root",findRepoRoot).extend("baseConfig",findBaseConfig).extend("exclude",["**/fixtures/**"]).extend("packages",findPackages).extend("checkedPackages",checkPackages).then(transmute.isolate("checkedPackages")),buildPackages=({configs:e=[]}={})=>Promise.all(e.map(e=>rollup.rollup({input:e.input,external:e.external,plugins:e.plugins}).then(t=>Promise.all(e.output.map(n=>t.write({file:n.file,format:n.format,banner:e.banner}))))));const babelConfig={babelrc:!1,presets:[["env",{modules:!1,targets:{node:"6"}}],"stage-0"],plugins:["external-helpers"],exclude:["node_modules/**"]};var buildRollupConfigs=({root:e=".",packages:t=[],baseConfig:n={dependencies:{}}}={})=>new Promise(r=>r([].concat(...t.filter(e=>e.bin).filter(e=>e.bin.constructor===Object).map(t=>Object.values(t.bin).map(r=>({input:path.resolve(e,"src/node_modules",t.name,r),external:[...Object.keys(n.dependencies),"fs","path","util"],output:[{file:path.resolve(e,"dist",t.name,r),format:"cjs"}],banner:"#!/usr/bin/env node",plugins:[nodeResolve({customResolveOptions:{moduleDirectory:"src/node_modules"},preferBuiltins:!0}),babel(babelConfig),uglify({},uglifyEs.minify),executable(),filesize()]})))))),build=()=>transmute__default({}).extend("root",findRepoRoot).extend("baseConfig",findBaseConfig).extend("exclude",["**/fixtures/**"]).extend("unfiltered",findPackages).extend("packages",({unfiltered:e})=>e.filter(e=>e.bin)).extend("configs",buildRollupConfigs).then(buildPackages);const kli=configure({defaultStyle:style}),cli=kli({commands:[{name:"list",aliases:["ls"],template:packageListTemplate,run:list},{name:"check",template:checkedPackagesTemplate,run:check},{name:"build",renderer:()=>{},run:build}]});cli.execute(process.argv.slice(2));
